=Description
Name: CW-P
Author name: SE
URL: http://www.geocities.jp/researcherinus/perl1
Description: The main objetcive of this script is for the author to study computer programing (Perl and C++) and Bioinformatics.  But, it may also be helpful for other people's study.  I do not know.
Development start date: March 9, 2008
=cut

# ----------------------------------- #
#  Open source libraries and pragma   #
# ----------------------------------- #

#!/usr/bin/perl -w
use strict;
use Time::HiRes qw/gettimeofday tv_interval/;
my $start_time = [gettimeofday];

# ----------------------- #
#    Custom libraries     #
# ----------------------- #

use lib './lib';
use IO_Fasta01;
use Rand_Str01;
#use NW01; # Used in Calc_Dist.pm
use NJ02;
use Calc_Dist01;
#use Newick01; # Used in NJ.pm

# ----------------------- #
#       Main routine      #
# ----------------------- #

$|++;

# ====== Read sequence information ====== #

my $filename = "sequences.fasta"; #$ARGV[0];
my ($ref_ids, $ref_seqs) = &io_fasta($filename); # IO_Fasta.pm

my @ids = @{$ref_ids};
my @seqs = @{$ref_seqs};

if ($#ids != $#seqs || $#ids == 0 || $#seqs == 0){
    print "Wrong format...\n";
    exit;
}
if ($#ids >= 20){
    print "Number of sequences should be equal to or less than 20...\n";
    exit;
}

my $seq_num = $#seqs+1;
my $sum_k = ($#seqs*($#seqs+1))/2;
print "File format looks OK.\n\n";
print "Starting alignment of $seq_num sequences...\n\n";

# ----- Prepare random seqs ----- #
my @rand_seqs;
foreach my $ori_seq (@seqs){
    my $rand_seq = &rand_str($ori_seq); # Rand_Str.pm
    push @rand_seqs, $rand_seq;
}


# ======   Needleman Wunsch   ====== #
# ====== & Calculate Distances ====== #

print "Calculating distance x $sum_k ...\n\n";
my $ref_d_matrix = calc_dist(\@seqs,\@rand_seqs); #Calc_Dist.pm


# ====== Neighbor Joining ====== #

print "Creating phylogenic tree...\n\n";
my ($str1,$str2) = &nj($ref_d_matrix); # NJ.pm


# ====== Report results ====== #

print "Start printing result...\n\n";
open OUT1, "> result.txt" or die "Cannot open result.txt $!";
my @alph = ('A'..'Z');
for(my $i=0;$i<=$#ids;$i++){
    my ($specname) = $ids[$i] =~ /\[(.+?)\]/;
    print OUT1 "$alph[$i]: $specname\n";
    print "$alph[$i]: $specname\n";
}
print OUT1 "\n";
print OUT1 "$str1\n";
print "\n";
print "$str1\n";
close OUT1;

open OUT2, "> newick.dnd" or die "Cannot open newick.dnd $!";
print OUT2 "$str2";
close OUT2;

my $end_time = [gettimeofday];
my $time_interval = tv_interval($start_time, $end_time);
my ($time_interval2) = $time_interval =~ /(\d+\.\d{1})\d+/;
print "\n\n";
print "Newick format is shown below and also saved in newick.dnd file.\n\n$str2";
print 'Use PHY.FI, TreeView etc. to see the tree.'."\n";
print '(cf. http://cgi-www.daimi.au.dk/cgi-chili/phyfi/go)'."\n\n";
print "Done. The process took $time_interval2 sec.\n\n";

print "See result.txt and newick.dnd.\n\n";

system("pause");

__END__
